Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/AlgorithmParameters.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/AlgorithmParameters.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/AlgorithmParameters.cshtml	(revision 8506)
@@ -0,0 +1,10 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.AlgorithmParameters
+
+@foreach (var itm in Model.Items) {
+    <div class="editor-label">
+        @Html.Label(itm.Value.Name, itm.Value.Name)
+    </div>
+    <div class="editor-label">
+        @Html.DisplayFor(model => itm.Value)
+    </div>
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/BoolValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/BoolValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/BoolValue.cshtml	(revision 8506)
@@ -0,0 +1,3 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.BoolValue
+
+@Model.Value
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalMatrix.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalMatrix.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalMatrix.cshtml	(revision 8506)
@@ -0,0 +1,16 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix
+
+<table>
+  <tr>
+    <th>@Model.Name</th>
+  </tr>
+  @for (int i = 0; i < Model.Value.Length; i++) {
+  <tr>
+    @for (int j = 0; j < Model.Value[j].Length; j++) {                      
+    <td>
+      @Model.Value[i][j]
+    </td>
+    }
+  </tr>
+  }
+</table> 
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalValue.cshtml	(revision 8506)
@@ -0,0 +1,3 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue
+
+@Model.Value
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalVector.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalVector.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/DecimalVector.cshtml	(revision 8506)
@@ -0,0 +1,14 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalVector
+ 
+<table>
+  <tr>
+    <th>@Model.Name</th>
+  </tr>
+  @for (int i = 0; i < Model.Value.Length; i++) {
+  <tr>
+    <td>
+      @Model.Value[i]
+    </td>
+  </tr>
+  }
+</table>
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/InputParameters.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/InputParameters.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/InputParameters.cshtml	(revision 8506)
@@ -0,0 +1,10 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.InputParameters
+
+@foreach (var itm in Model.Items) {
+    <div class="editor-label">
+        @Html.Label(itm.Value.Name, itm.Value.Name)
+    </div>
+    <div class="editor-label">
+        @Html.DisplayFor(model => itm.Value)
+    </div>
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/TypeValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/TypeValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/DisplayTemplates/TypeValue.cshtml	(revision 8506)
@@ -0,0 +1,3 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.TypeValue
+           
+@Model.Value
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/AlgorithmParameters.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/AlgorithmParameters.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/AlgorithmParameters.cshtml	(revision 8506)
@@ -0,0 +1,10 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.AlgorithmParameters
+
+@foreach (var itm in Model.Items) {
+    <div class="editor-label">
+        @Html.Label(itm.Value.Name, itm.Value.Name)
+    </div>
+    <div class="editor-field">
+        @Html.EditorFor(model => itm.Value)
+    </div>
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/BoolValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/BoolValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/BoolValue.cshtml	(revision 8506)
@@ -0,0 +1,3 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.BoolValue
+
+@Html.Raw(Html.CheckBoxFor(model => Model.Value).ToString().Replace("itm.Value.Value", Model.Name))
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalMatrix.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalMatrix.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalMatrix.cshtml	(revision 8506)
@@ -0,0 +1,16 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalMatrix
+
+<table>
+  <tr>
+    <th>@Model.Name</th>
+  </tr>
+  @for (int i = 0; i < Model.Value.Length; i++) {
+  <tr>
+    @for (int j = 0; j < Model.Value[j].Length; j++) {                      
+    <td>
+      @Html.Raw(Html.TextBoxFor(model => Model.Value[i][j]).ToString().Replace("itm.Value.Value[" + i + "][" + j + "]", Model.Name + "_" + i + "_" + j))
+    </td>
+    }
+  </tr>
+  }
+</table> 
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalValue.cshtml	(revision 8506)
@@ -0,0 +1,4 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalValue
+
+@Html.Raw(Html.TextBoxFor(model => Model.Value).ToString().Replace("itm.Value.Value", Model.Name))
+@Html.Raw(Html.ValidationMessageFor(model => Model.Value).ToString().Replace("itm.Value.Value", Model.Name))
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalVector.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalVector.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/DecimalVector.cshtml	(revision 8506)
@@ -0,0 +1,14 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.DecimalVector
+ 
+<table>
+  <tr>
+    <th>@Model.Name</th>
+  </tr>
+  @for (int i = 0; i < Model.Value.Length; i++) {
+  <tr>
+    <td>
+      @Html.Raw(Html.TextBoxFor(model => Model.Value[i]).ToString().Replace("itm.Value.Value[" + i + "]", Model.Name + "_" + i))
+    </td>
+  </tr>
+  }
+</table>
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/InputParameters.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/InputParameters.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/InputParameters.cshtml	(revision 8506)
@@ -0,0 +1,10 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.InputParameters
+
+@foreach (var itm in Model.Items) {
+    <div class="editor-label">
+        @Html.Label(itm.Value.Name, itm.Value.Name)
+    </div>
+    <div class="editor-field">
+        @Html.EditorFor(model => itm.Value)
+    </div>
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/TypeValue.cshtml
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/TypeValue.cshtml	(revision 8506)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/EditorTemplates/TypeValue.cshtml	(revision 8506)
@@ -0,0 +1,5 @@
+﻿@model HeuristicLab.Services.Optimization.ControllerService.Model.TypeValue
+@{
+var list = new SelectList(Model.Options, Model.Value);
+@Html.Raw(Html.DropDownListFor(model => list, list).ToString().Replace("itm.Value.list", Model.Name))
+}