Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8520)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8521)
@@ -38,4 +38,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="ALGLIB-3.6.0, Version=3.6.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
@@ -114,4 +117,5 @@
   <ItemGroup>
     <Compile Include="AlgorithmBehaviorHelpers.cs" />
+    <Compile Include="LinearLeastSquaresFitting.cs" />
     <Compile Include="RunCollectionStatisticalTabularView.cs">
       <SubType>UserControl</SubType>
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/LinearLeastSquaresFitting.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/LinearLeastSquaresFitting.cs	(revision 8521)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/LinearLeastSquaresFitting.cs	(revision 8521)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  public class LinearLeastSquaresFitting {
+    public static void Calculate(double[] dataPoints, out double a1, out double a0) {
+      double sxy = 0.0;
+      double sxx = 0.0;
+      int n = dataPoints.Count();
+      double sy = dataPoints.Sum();
+      double sx = ((n - 1) * n) / 2;
+      double avgy = sy / n;
+      double avgx = sx / n;
+
+      for (int i = 0; i < n; i++) {
+        sxy += i * dataPoints[i];
+        sxx += i * i;
+      }
+
+      a1 = (sxy - (n * avgx * avgy)) / (sxx - (n * avgx * avgx));
+      a0 = avgy - a1 * avgx;
+    }
+
+    public static double CalculateError(double[] dataPoints, double a1, double a0) {
+      double r = 0.0;
+      for (int i = 0; i < dataPoints.Count(); i++) {
+        double y = a1 * i + a0;
+        r += Math.Abs(dataPoints[i] - y);
+      }
+      return r;
+    }
+  }
+}
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 8520)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/RunCollectionStatisticalTabularView.cs	(revision 8521)
@@ -24,4 +24,5 @@
 using System.Linq;
 using System.Windows.Forms;
+using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers;
 using HeuristicLab.Common;
 using HeuristicLab.Core.Views;
@@ -155,5 +156,5 @@
       string rowName = (string)dataRowComboBox.SelectedItem;
 
-      string[] columnNames = new string[] { "Count", "Minimum", "Maximum", "Average", "Median", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile" };
+      string[] columnNames = new string[] { "Count", "Minimum", "Maximum", "Average", "Median", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile", "Gradient", "Absolut Error" };
 
       var runs = Content.Where(x => x.Results.ContainsKey(resultName));
@@ -178,14 +179,19 @@
         double percentile25 = values.Percentile(0.25);
         double percentile75 = values.Percentile(0.75);
-
-        dt[i,0] = cnt.ToString();
-        dt[i,1] = min.ToString();
-        dt[i,2] = max.ToString();
-        dt[i,3] = avg.ToString();
-        dt[i,4] = median.ToString();
-        dt[i,5] = stdDev.ToString();
-        dt[i,6] = variance.ToString();
-        dt[i,7] = percentile25.ToString();
-        dt[i,8] = percentile75.ToString();
+        double k, d, r;
+        LinearLeastSquaresFitting.Calculate(values.ToArray(), out k, out d);
+        r = LinearLeastSquaresFitting.CalculateError(values.ToArray(), k, d);
+
+        dt[i, 0] = cnt.ToString();
+        dt[i, 1] = min.ToString();
+        dt[i, 2] = max.ToString();
+        dt[i, 3] = avg.ToString();
+        dt[i, 4] = median.ToString();
+        dt[i, 5] = stdDev.ToString();
+        dt[i, 6] = variance.ToString();
+        dt[i, 7] = percentile25.ToString();
+        dt[i, 8] = percentile75.ToString();
+        dt[i, 9] = k.ToString();
+        dt[i, 10] = r.ToString();
 
         i++;